/*----------------------------------------------------------------------------
FILE NAME:     rstream.h

AUTHOR:        Stefano Basagni

CREATED:       February 1999

DESCRIPTION: This file contains the class definition for a random stream
             whose implementation is in the file rstrea.cpp.

---
Copyright (C) 2003 Stefano Basagni

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

To receive a copy of the GNU General Public License write to
the Free Software Foundation, Inc., 59 Temple Place - Suite
330, Boston, MA 02111-1307, USA.

Stefano Basagni can be contacted at basagni@ece.neu.edu.

----------------------------------------------------------------------------*/
#ifndef RSTREAM_H
#define RSTREAM_H

class Rstream{
 public:

   Rstream( unsigned long int );
   unsigned long int get_xi() const { return xi; };
   double uniform01();
   double uniform( double, double ); 
   double poisson( float );
   unsigned long int uniform_discrete( unsigned long int, 
				       unsigned long int );
 private:

   // Value of the last number generated according to the linear
   // congruential generator theory
   unsigned long int xi; 
   float lngamma ( float ) const;

};

#endif


